#!/usr/bin/env python
# -*- coding: utf-8 -*-



import os
import subprocess
import shutil
import random
import string
import gtk
import gtk.glade


import gettext
import locale

locale.textdomain("lliurex-flash-video-saver")
gettext.textdomain("lliurex-flash-video-saver")
_=locale.gettext

class FlashCacher:
	
	def __init__(self):


		self.user=os.environ['USER']			
		
		self.get_processes()

	
	#def init
	

	def get_processes(self):

		p1=subprocess.Popen(['ps','aux'],stdout=subprocess.PIPE)
		p2=subprocess.Popen(['grep','flashplayer'],stdin=p1.stdout,stdout=subprocess.PIPE)
		p1.stdout.close()
		output=p2.communicate()[0]
		


		output=output.rstrip('\n')

		tmp=output.split("\n")

		tmp.pop(len(tmp)-1)

		self.files_found=False

		self.list=[]
		self.file_list=[]

		for item in tmp:
			tmp2=item.split(" ")
			tmp3=[]
			for item2 in tmp2:
				if(item2!=""):
					tmp3.append(item2)
					
			self.list.append(tmp3)
			
		if len(self.list)>0:
			self.files_found=True

		
	#def get_processes

	def get_files_from_browser(self,browser):
		
		list=None
		for process in self.list:
			if process[10].find(browser)!=-1:
				list=process
				
		if list==None:
			print "No flash player process found in " + browser
		else:
			self.get_files_from_process(list)
			
	#def get files from browser


	def get_files_from_process(self,process_info):
		
		proc_dir="/proc/" + process_info[1] + "/fd"
		
		p1=subprocess.Popen(['ls','-la',proc_dir],stdout=subprocess.PIPE)
		p2=subprocess.Popen(['grep','/tmp/Flash'],stdin=p1.stdout,stdout=subprocess.PIPE)
		p1.stdout.close()
		output=p2.communicate()[0]		
		output=output.rstrip('\n')
		tmp=output.split('\n')
		
		for item in tmp:
			tmp2=item.split(' ')
			tmp3=[]
			for item2 in tmp2:
				if(item2!=""):
					tmp3.append(item2)
			self.file_list.append(proc_dir + "/" + tmp3[7])
			
	#get_files
	
	
	def get_files_from_all(self):
		
		self.clean_file_list()
		self.get_processes()		
		if self.files_found:
		
			for process_info in self.list:

				self.get_files_from_process(process_info)
		
	#def get_files_from_all
	
	def print_file_list(self):

		count=1
		print ""
		print "[!] LIST OF PROCESSES USING FLASHPLAYER [!]\n"
		for process_info in self.list:
			
			print "[" + str(count) + "] Process ID: " + process_info[1]
			browser=""
			if process_info[10].find("opera")!=-1:
				browser="Opera"
			if process_info[10].find("firefox")!=-1:
				browser="Firefox"
			if process_info[10].find("chromium")!=-1:
				browser="Chromium Browser"
			if browser=="":
				browser=process_info[10]
			print "    Used by: " + browser 
			count+=1
			print "    Files:"
			for file in self.file_list:
				if file.find(process_info[1])!=-1:
					print "\t" + file
			print ""
			
	#def print_file_list
	
	def clean_file_list(self):
		
		self.file_list=[]
		
	#clean_file_list
	
	def copy_files(self,dest):
		
		base_file_name="FlashLLX"
		char_set=string.ascii_lowercase + string.digits
		
		for file in self.file_list:
		
			tmp=file.split('/')
			file_dest=dest+base_file_name+tmp[2]+tmp[4]
			print "Copying "  + file + " to " + file_dest + " ... "
			shutil.copy(file,file_dest)
			
			
	#def copy_files
	 
	 
#class flash manager






class LlxFC:
	
	def __init__(self):
		
		self.counter=0
		
		self.flash=FlashCacher()
		
		
		self.hbox_list=[]
		
		if (os.path.exists("rsrc/window.glade")):
			self.glade= gtk.glade.XML("rsrc/window.glade")
		else:
			self.glade=gtk.glade.XML("/usr/share/lliurex-flash-video-catcher/rsrc/window.glade")
			
			
		self.window=self.glade.get_widget("window")
		
		self.buttonRefresh=self.glade.get_widget("buttonRefresh")
		self.buttonRefresh.connect("clicked",self.refresh_clicked)
		
		self.buttonExit=self.glade.get_widget("buttonExit")
		self.buttonExit.connect("clicked",gtk.main_quit)
		
		
		self.msgLabel=self.glade.get_widget("msgLabel")
		
		self.vboxMain=self.glade.get_widget("vboxMain")
		
		self.window.show_all()
		self.window.connect("destroy",gtk.main_quit)
		
		self.populate_vbox()
		
	
	#def __init__

	def save_clicked(self,widget,path):
		
		chooser = gtk.FileChooserDialog(title=None,action=gtk.FILE_CHOOSER_ACTION_SAVE,   buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_SAVE,gtk.RESPONSE_OK))
		base_file_name="FlashLLX"
		tmp=path.split('/')
		file_dest=base_file_name+tmp[2]+tmp[4]
		chooser.set_current_name(file_dest)
		response = chooser.run()
		
		if response == gtk.RESPONSE_OK:
			shutil.copy(path,chooser.get_filename())
			self.msgLabel.set_text(chooser.get_filename() + _(" saved"))
			chooser.destroy()
		elif response == gtk.RESPONSE_CANCEL:
			chooser.destroy()
		else:
			chooser.destroy()



		
	#def save_clicked


	def refresh_clicked(self,widget):
		
		print "[LlxFC] Refreshing..."
		
		self.populate_vbox()
		
	#refresh_clicked


	def populate_vbox(self):
		
		if len(self.hbox_list)>0:
			for hbox in self.hbox_list:
				self.vboxMain.remove(hbox)
			self.hbox_list=[]
			self.counter=0
		
		try:
			self.flash.get_files_from_all()
			for item in self.flash.file_list:
				self.add_video(item)
		except Exception as e:
			print e
		
	#def populate_vbox


	def add_video(self,path):
		
		hbox=gtk.HBox()
		label=gtk.Label("[" + str(self.counter+1) + "]")
		hbox.pack_start(label,True,5)
		
		p1 = subprocess.Popen(["ffmpegthumbnailer","-i", path, "-o", "/tmp/." + str(self.counter)], stdout=subprocess.PIPE)
		
		output = p1.communicate()[0]		
		image=gtk.Image()
		image.set_from_file("/tmp/." + str(self.counter))
		hbox.pack_start(image,True,5)
		vbox=gtk.VBox()
		button=gtk.Button(_("Save"))
		button.connect("clicked",self.save_clicked,path)
		vbox.pack_start(button,True,False,5)
		hbox.pack_start(vbox,False,True,5)
		hbox.show_all()
		
		self.hbox_list.append(hbox)
		
		self.vboxMain.pack_start(hbox,False,False,5)
		self.counter+=1
		
	#def add_video


	
	
#class Window



win=LlxFC()
gtk.main()

